Getting Started with Editor Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.


Rich Text Editor

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Editor module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.editor.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-editor id="editor"></smart-editor>

    Host container (id matches appendTo on Smart.Editor):

    <div id="editorContainer"></div>

  5. Initialize after the module loads: define a const editorOptions object, then either bind with Smart('#editor', ...) on the semantic tag or use new Smart.Editor({ ...editorOptions, appendTo: '#editorContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.editor.js';
    
    	const editorOptions = {};
    
    	// Option A - semantic <smart-editor> with id="editor"
    	Smart('#editor', class {
    		get properties() {
    			return editorOptions;
    		}
    	});
    
    	// Option B - host div id="editorContainer"
    	// const editorInstance = new Smart.Editor({
    	// 	...editorOptions,
    	// 	appendTo: '#editorContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myEditor = new Smart.Editor('#editor', editorOptions);
    	// document.body.appendChild(myEditor);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Editor('#editor', editorOptions) with appendChild, and document.createElement('smart-editor') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Editor({ ...options, appendTo: '#...' }); new Smart.Editor('#editor', editorOptions) plus appendChild on the returned element; and document.createElement('smart-editor') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myEditor = new Smart.Editor('#editor', editorOptions)):

	const editorOptions = {};
	const myEditor = new Smart.Editor('#editor', editorOptions);
	document.body.appendChild(myEditor);
	

Create with document.createElement('smart-editor'), assign properties (same as any custom element), then append:

	const editorOptions = {};
	const editor = document.createElement('smart-editor');
	Object.assign(editor, editorOptions);
	document.body.appendChild(editor);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.editor.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const editorOptions = {};
		const editor = new Smart.Editor({
			...editorOptions,
			appendTo: '#editorContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('editor-container');
container.appendChild(editor);
	

Remove from the DOM:

editor.remove();
	

Set a property:

editor.disabled = true;
editor.theme = 'dark';
	

Get a property value:

const isDisabled = editor.disabled;
const currentTheme = editor.theme;
	

Invoke a method:

editor.refresh();
editor.focus();
	

Add event listener:

editor.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.oldValue);
});
	

Remove event listener:

const handleEditorEvent = (event) => {
    console.log('change triggered:', event.detail.oldValue);
};

editor.addEventListener('change', handleEditorEvent);
editor.removeEventListener('change', handleEditorEvent);
	

Troubleshooting

How do I get the editor content?
Use editor.value to get the HTML content, or editor.textContent for plain text.
How do I insert content at cursor position?
Use editor.executeCommand('insertHTML', '<span>inserted</span>') to insert at the current cursor position.

Accessibility

The Editor component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Editor Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/editor/overview/App.jsx


Rich Text Editor

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import { useRef } from "react";
import { Editor } from 'smart-webcomponents-react/editor';

const App = () => {
	
	const editorRef = useRef(null);

	const toolbarItems = ['Bold', 'Italic', 'Underline', 'StrikeThrough',
		'FontName', 'FontSize', 'FontColor', 'BackgroundColor',
		'LowerCase', 'UpperCase', '|',
		'Formats', 'Alignment', 'OrderedList', 'UnorderedList',
		'Outdent', 'Indent', '|',
		'hyperlink', 'table', 'Image', '|', 'ClearFormat', 'Print',
		'SourceCode', 'splitmode', 'FullScreen', '|', 'Undo', 'Redo', 'subscript', 'superscript', 'delete'
	];

	const initEditor = () => {
	  if (editorRef.current) {
		editorRef.current.expandToolbar?.(); // optional chaining
	  }
	};

	return (
		<div>
			<Editor onReady={initEditor} ref={editorRef} id="editor" toolbarItems={toolbarItems}>
				<div>
					<h2>What is Lorem Ipsum?</h2>
					<p><strong>Lorem Ipsum</strong> is simply dummy text of the printing and typesetting
						industry. Lorem Ipsum has been the industry's standard dummy text ever
						since the 1500s, when an unknown printer took a galley of type and scrambled
						it to make a type specimen book. It has survived not only five centuries,
						but also the leap into electronic typesetting, remaining essentially unchanged.
						It was popularised in the 1960s with the release of Letraset sheets containing
						Lorem Ipsum passages, and more recently with desktop publishing software
						like Aldus PageMaker including versions of Lorem Ipsum. <a href="www.htmlelements.com"
							title="Smart Elements">Smart Elements</a>
					</p>
					<table className="wd-Table">
						<thead>
							<tr>
								<th>First Name</th>
								<th>Last Name</th>
								<th>Email</th>
								<th>Actions</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td>Jane</td>
								<td>Doe</td>
								<td>sample@example.org</td>
								<td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
								</td>
							</tr>
							<tr>
								<td>Jane</td>
								<td>Doe</td>
								<td>sample@example.org</td>
								<td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
								</td>
							</tr>
							<tr>
								<td>Jane</td>
								<td>Doe</td>
								<td>sample@example.org</td>
								<td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
								</td>
							</tr>
						</tbody>
					</table>
				</div>
				<div>
					<h2>Why do we use it?</h2>
					<p>It is a long established fact that a reader will be distracted by the
						readable content of a page when looking at its layout. The point of using
						Lorem Ipsum is that it has a more-or-less normal distribution of letters,
						as opposed to using 'Content here, content here', making it look like readable
						English. Many desktop publishing packages and web page editors now use
						Lorem Ipsum as their default model text, and a search for 'lorem ipsum'
						will uncover many web sites still in their infancy. Various versions have
						evolved over the years, sometimes by accident, sometimes on purpose (injected
						humour and the like).</p>
					<p>
						<img src="./../../../src/images/Album.png" width="100px" height="100px" />
					</p>
				</div>
				<br />
				<div>
					<h2>Where does it come from?</h2>
					<p>Contrary to popular belief, Lorem Ipsum is not simply random text. It
						has roots in a piece of classical Latin literature from 45 BC, making it
						over 2000 years old. Richard McClintock, a Latin professor at Hampden-Sydney
						College in Virginia, looked up one of the more obscure Latin words, consectetur,
						from a Lorem Ipsum passage, and going through the cites of the word in
						classical literature, discovered the undoubtable source. Lorem Ipsum comes
						from sections 1.10.32 and 1.10.33 of "de Finibus Bonorum et Malorum" (The
						Extremes of Good and Evil) by Cicero, written in 45 BC. This book is a
						treatise on the theory of ethics, very popular during the Renaissance.
						The first line of Lorem Ipsum, "Lorem ipsum dolor sit amet..", comes from
						a line in section 1.10.32.</p>
					<p>The standard chunk of Lorem Ipsum used since the 1500s is reproduced below
						for those interested. Sections 1.10.32 and 1.10.33 from "de Finibus Bonorum
						et Malorum" by Cicero are also reproduced in their exact original form,
						accompanied by English versions from the 1914 translation by H. Rackham.</p>
				</div>
				<div>
					<h2>Where can I get some?</h2>
					<p>There are many variations of passages of Lorem Ipsum available, but the
						majority have suffered alteration in some form, by injected humour, or
						randomised words which don't look even slightly believable. If you are
						going to use a passage of Lorem Ipsum, you need to be sure there isn't
						anything embarrassing hidden in the middle of text. All the Lorem Ipsum
						generators on the Internet tend to repeat predefined chunks as necessary,
						making this the first true generator on the Internet. It uses a dictionary
						of over 200 Latin words, combined with a handful of model sentence structures,
						to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum
						is therefore always free from repetition, injected humour, or non-characteristic
						words etc.</p>
				</div>
			</Editor>
		</div>
	);
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Troubleshooting

How do I get the editor content?
Use editor.value to get the HTML content, or editor.textContent for plain text.
How do I insert content at cursor position?
Use editor.executeCommand('insertHTML', '<span>inserted</span>') to insert at the current cursor position.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Editor, EditorProps } from 'smart-webcomponents-react/editor';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Editor component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Editor - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/editor/overview


Rich Text Editor

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import EditorModule from smart-webcomponents-angular/editor: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { EditorModule } from 'smart-webcomponents-angular/editor';

4 Root component (standalone)

Add EditorModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { EditorComponent } from 'smart-webcomponents-angular/editor';

import { EditorModule } from 'smart-webcomponents-angular/editor';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ EditorModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('editor', { read: EditorComponent, static: false }) editor!: EditorComponent;

    toolbarItems: any = ['Bold', 'Italic', 'Underline', 'StrikeThrough',
        'FontName', 'FontSize', 'FontColor', 'BackgroundColor',
        'LowerCase', 'UpperCase', '|',
        'Formats', 'Alignment', 'OrderedList', 'UnorderedList',
        'Outdent', 'Indent', '|',
        'hyperlink', 'table', 'Image', '|', 'ClearFormat', 'Print',
        'SourceCode', 'splitmode', 'FullScreen', '|', 'Undo', 'Redo', 'subscript', 'superscript', 'delete'];

    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.
        this.editor.expandToolbar();
    };
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-editor as needed:

 <smart-editor #editor id="editor" [toolbarItems]="toolbarItems">
    <div>
         <h2>What is Lorem Ipsum?</h2>
        <p><strong>Lorem Ipsum</strong> is simply dummy text of the printing and typesetting
            industry. Lorem Ipsum has been the industry's standard dummy text ever
            since the 1500s, when an unknown printer took a galley of type and scrambled
            it to make a type specimen book. It has survived not only five centuries,
            but also the leap into electronic typesetting, remaining essentially unchanged.
            It was popularised in the 1960s with the release of Letraset sheets containing
            Lorem Ipsum passages, and more recently with desktop publishing software
            like Aldus PageMaker including versions of Lorem Ipsum. <a href="www.htmlelements.com"
            title="Smart Elements">Smart Elements</a>
        </p>
        <table class="wd-Table">
            <thead>
                <tr>
                    <th>First Name</th>
                    <th>Last Name</th>
                    <th>Email</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>Jane</td>
                    <td>Doe</td>
                    <td>sample@example.org</td>
                    <td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
                    </td>
                </tr>
                <tr>
                    <td>Jane</td>
                    <td>Doe</td>
                    <td>sample@example.org</td>
                    <td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
                    </td>
                </tr>
                <tr>
                    <td>Jane</td>
                    <td>Doe</td>
                    <td>sample@example.org</td>
                    <td><a href="#">View</a> - <a href="#">Edit</a> - <a href="#">Delete</a>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    <div>
         <h2>Why do we use it?</h2>
        <p>It is a long established fact that a reader will be distracted by the
            readable content of a page when looking at its layout. The point of using
            Lorem Ipsum is that it has a more-or-less normal distribution of letters,
            as opposed to using 'Content here, content here', making it look like readable
            English. Many desktop publishing packages and web page editors now use
            Lorem Ipsum as their default model text, and a search for 'lorem ipsum'
            will uncover many web sites still in their infancy. Various versions have
            evolved over the years, sometimes by accident, sometimes on purpose (injected
            humour and the like).</p>
        <p>
            <img src="./../../../src/images/Album.png" width="100px" height="100px"/>
        </p>
    </div>
    <br>
    <div>
         <h2>Where does it come from?</h2>
        <p>Contrary to popular belief, Lorem Ipsum is not simply random text. It
            has roots in a piece of classical Latin literature from 45 BC, making it
            over 2000 years old. Richard McClintock, a Latin professor at Hampden-Sydney
            College in Virginia, looked up one of the more obscure Latin words, consectetur,
            from a Lorem Ipsum passage, and going through the cites of the word in
            classical literature, discovered the undoubtable source. Lorem Ipsum comes
            from sections 1.10.32 and 1.10.33 of "de Finibus Bonorum et Malorum" (The
            Extremes of Good and Evil) by Cicero, written in 45 BC. This book is a
            treatise on the theory of ethics, very popular during the Renaissance.
            The first line of Lorem Ipsum, "Lorem ipsum dolor sit amet..", comes from
            a line in section 1.10.32.</p>
        <p>The standard chunk of Lorem Ipsum used since the 1500s is reproduced below
            for those interested. Sections 1.10.32 and 1.10.33 from "de Finibus Bonorum
            et Malorum" by Cicero are also reproduced in their exact original form,
            accompanied by English versions from the 1914 translation by H. Rackham.</p>
    </div>
    <div>
         <h2>Where can I get some?</h2>
        <p>There are many variations of passages of Lorem Ipsum available, but the
            majority have suffered alteration in some form, by injected humour, or
            randomised words which don't look even slightly believable. If you are
            going to use a passage of Lorem Ipsum, you need to be sure there isn't
            anything embarrassing hidden in the middle of text. All the Lorem Ipsum
            generators on the Internet tend to repeat predefined chunks as necessary,
            making this the first true generator on the Internet. It uses a dictionary
            of over 200 Latin words, combined with a handful of model sentence structures,
            to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum
            is therefore always free from repetition, injected humour, or non-characteristic
            words etc.</p>
    </div>
</smart-editor>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put EditorModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put EditorModule from smart-webcomponents-angular/editor on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { EditorModule } from 'smart-webcomponents-angular/editor';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, EditorModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Troubleshooting

How do I get the editor content?
Use editor.value to get the HTML content, or editor.textContent for plain text.
How do I insert content at cursor position?
Use editor.executeCommand('insertHTML', '<span>inserted</span>') to insert at the current cursor position.

Accessibility

The Editor component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.